commit 1214ebb39cd250fda678ec89c785fcea86888a89
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Fri Jun 24 22:21:39 2022 +0200

    Fortran: fix checking of arguments to UNPACK when MASK is a variable [PR105813]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/105813
            * check.c (gfc_check_unpack): Try to simplify MASK argument to
            UNPACK so that checking of the VECTOR argument can work when MASK
            is a variable.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/105813
            * gfortran.dg/unpack_vector_1.f90: New test.
    
    (cherry picked from commit f21f17f95c0237f4f987a5fa9f1fa9c7e0db3c40)

diff --git a/gcc/fortran/check.c b/gcc/fortran/check.c
index 44e2da65a4c..488c9aff94b 100644
--- a/gcc/fortran/check.c
+++ b/gcc/fortran/check.c
@@ -6329,6 +6329,8 @@ gfc_check_unpack (gfc_expr *vector, gfc_expr *mask, gfc_expr *field)
   if (!same_type_check (vector, 0, field, 2))
     return false;
 
+  gfc_simplify_expr (mask, 0);
+
   if (mask->expr_type == EXPR_ARRAY
       && gfc_array_size (vector, &vector_size))
     {
diff --git a/gcc/testsuite/gfortran.dg/unpack_vector_1.f90 b/gcc/testsuite/gfortran.dg/unpack_vector_1.f90
new file mode 100644
index 00000000000..5347c111e8f
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/unpack_vector_1.f90
@@ -0,0 +1,12 @@
+! { dg-do compile }
+! PR fortran/105813
+! Fix checking of VECTOR argument to UNPACK when MASK is a variable.
+! Contributed by G.Steinmetz
+
+program p
+  logical, parameter :: mask(2,2) = reshape ([.true.,  .true.,  &
+                                              .false., .true.], &
+                                              shape (mask))
+  print *, unpack ([1,2,3], mask, 0) ! OK
+  print *, unpack ([1,2],   mask, 0) ! { dg-error "must provide at least" }
+end

